﻿/*
■ライブラリ:汎用メソッド群　　v210811
 
    ・Act_CreateSmartObj　--新規でスマートオブジェを生成
    ・Act_LayersetHidden     --レイヤーセットの非表示化
    ・Act_LayerHidden     --レイヤーの非表示化
    ・Act_CreateFolder　　--フォルダの作成（保存先）
    ・Act_CreateLayerMask　　--レイヤーマスクを作成（#000000）　
    ・Act_CreateLayerSet　　--指定したレイヤーセットを作成
    ・Act_MoveInsideLayerSet　　--指定したレイヤーセットの内部に移動する
    
    ・Check_Alpha　--アルファチェンネルチェック
    ・Check_DocSize　--ドキュメントサイズのチェック（4の倍数）

    ・Save_Branch　　--各フォーマットへの分岐
    ・Save_Png
    ・Save_Jpg
    ・Save_Tga
    ・Save_Psd
    ・Save_WebJpg
    ・Save_WebPng
    ・Save_WebGif
    ・Save_WebOpen
    
    ・汎用プログレスバー
*/

/*
■新規でスマートオブジェを生成
*/
function Act_CreateSmartObj(){
    try{
        var idnewPlacedLayer = stringIDToTypeID( "newPlacedLayer" );
        executeAction( idnewPlacedLayer, undefined, DialogModes.NO );
        }catch(e) {
            alert("error("+e+")");
    }
}
/*
■レイヤーセット表示の非表示化
*/
function Act_LayersetHidden(layerSets){
    //レイヤーセットの非表示化
    for (var i=0; i < layerSets.length ; i++){
            layerSets[i].visible = false;
    }   
}
/*
■レイヤー表示の非表示化
*/
function Act_LayerHidden(layer){
    //レイヤーの非表示化
    for (var i=0; i < layer.length ; i++){
            layer[i].visible = false;
    }   
}

/*
■フォルダの作成
*/
function Act_CreateFolder(folder){
    try{    
            var arrayFlg = false;
            if(folder instanceof Array){
                var folderNum = folder.length;
                arrayFlg = true;
            }else{
                var folderNum = 1;
            }
            for (var i=0 ; i < folderNum ; i++){
                if(arrayFlg){
                    var foldername = newPath  +"/"+folder[i];
                }else{
                    var foldername = newPath  +"/"+folder;
                }
                 var folderObj = new Folder(foldername); 
                 var flag = folderObj.create(); 
                 if(flag != true) { 
                     throw "フォルダ作成に失敗しました";
                 } 
            }
        }catch(e) {
            alert("error("+e+")");
    }
}
/*
■レイヤーマスクを作成（#000000）
*/
function Act_CreateLayerMask(){
    try{
        var idMk = charIDToTypeID( "Mk  " );
        var desc1 = new ActionDescriptor();
        var idNw = charIDToTypeID( "Nw  " );
        var idChnl = charIDToTypeID( "Chnl" );
        desc1.putClass( idNw, idChnl );
        var idAt = charIDToTypeID( "At  " );
            var ref1 = new ActionReference();
            var idChnl = charIDToTypeID( "Chnl" );
            var idChnl = charIDToTypeID( "Chnl" );
            var idMsk = charIDToTypeID( "Msk " );
            ref1.putEnumerated( idChnl, idChnl, idMsk );
        desc1.putReference( idAt, ref1 );
        var idUsng = charIDToTypeID( "Usng" );
        var idUsrM = charIDToTypeID( "UsrM" );
        var idHdAl = charIDToTypeID( "HdAl" );
        desc1.putEnumerated( idUsng, idUsrM, idHdAl );
        executeAction( idMk, desc1, DialogModes.NO );
        }catch(e) {
            alert("error("+e+")");
    }
}

/*
■指定したレイヤーセットを作成
*/
function Act_CreateLayerSet(name){
    try{
            var laySetObj= docObj.layerSets.add();
            laySetObj.name= name;
        }catch(e) {
            alert("error("+e+")");
    }
}

/*
■指定したレイヤーセットの内部に移動する
*/
function Act_MoveInsideLayerSet(name){
    try{
            var layerObj= docObj.activeLayer;
            var relatveObj= docObj.layerSets[name];
            layerObj.move(relatveObj,  ElementPlacement.PLACEATEND);
        }catch(e) {
            alert("error("+e+")");
    }
}


/*
■アルファチャンネルをチェックし存在しなければ新規で用意する(他のアルファチャンネルがある場合はすべて削除する)
　▼PSDデータのRGBカラーモードでのみ対応です　そのほかは未対応です
*/
function Check_Alpha(docObj){
    try {
        var colMode = docObj.mode;
        if(colMode !="DocumentMode.RGB"){
            throw "RGBカラーモードではありません";
        }
        var aNum = docObj.channels.length
        var achFlag = 0;

        var colMode = activeDocument.mode;                
        if(colMode == DocumentMode.RGB){
            if(aNum>3){
                    for (var i=aNum-1; i >=3 ; i--){
                        activeDocument.channels[i].remove();
                    }
            }
        }
        var  chObj = activeDocument.channels.add();
        chObj.name = "ｱﾙﾌｧﾁｬﾝﾈﾙ 1";
    }
    catch(e){
        alert("error("+e+")");
    }
}

/*
■ドキュメントサイズが4の倍数であるかチェックする
*/
function Check_DocSize(docObj,docName){
    const MULTIPLE = 4;//倍数
    
    //ドキュメントの横幅縦幅検出
    preferences.rulerUnits = Units.PIXELS;
    var w = docObj.width.value;
    var h = docObj.height.value;
    //4の倍数か診断
    var w = Math.round(w) % MULTIPLE;
    var h =Math.round(h) % MULTIPLE;
    try{
        if (w > 0 || h > 0) {
            throw "『"　+ docName+ "』は\nテクスチャサイズが" +MULTIPLE+"の倍数ではありません";
        }
        }catch(e) {
            alert("error("+e+")");
    }
}
/*
■psdフォーマット変更保存
*/
const FORMAT_DATA={
    _interlaced:false,
    _colorProfile:true,
    _aChannels:true,
    _rleCompression:false,
    _annotations:true,
    _layers:true,
    _spotColors:true,
    _formatOptions:FormatOptions.OPTIMIZEDBASELINE,
    _matte:MatteType.NONE,
    _resolution:TargaBitsPerPixels.SIXTEEN,
    _quality:12,
    _scans:3,
    _webJpgQuality:60,
    _webGifQuality:0,
};

//関数：psdを各フォーマットへ保存
function Save_Branch(saveFormat){
    //アクティブレイヤーの設定とドキュメントの複製
    activeDocument.activeLayer = activeDocument.layers[0];
    switch(saveFormat){
      case "tga":
            Save_Tga(newName,newPath);break;
      case "png":
            Save_Png(newName,newPath);break;
      case "jpg":
            Save_Jpg(newName,newPath);break;
      case "psd":
            Save_Psd(newName,newPath);break;
      case "webPng":
            Save_WebPng(newName,newPath);break;
      case "webJpg":
            Save_WebJpg(newName,newPath);break;
      case "webGif":
            Save_WebGif(newName,newPath);break;
      case "webOpen":
            Save_WebOpen(newName,newPath);break;
      default :break;
    }
}
//関数：png保存
function Save_Png(newName,newPath){
    fileObj = new File(newPath+"/"+ newName +".png");
    pngOpt = new PNGSaveOptions();
    pngOpt.interlaced = FORMAT_DATA._interlaced;
    activeDocument.saveAs(fileObj, pngOpt, true, Extension.LOWERCASE);
}

//関数：jpg保存
function Save_Jpg(newName,newPath){
    var num_1 = FORMAT_DATA._quality; 
    if(num_1 < 0){
      num_1 = 0 ;  
    }
    if(num_1 > 12){
      num_1 = 12 ;  
    }
    var num_2 = FORMAT_DATA._scans;  
    if(num_2 < 3){
      num_2 = 3 ;  
    }
    if(num_2 > 5){
      num_2 = 5 ;  
    }

    fileObj = new File(newPath+"/"+ newName +".jpg");
    jpegOpt = new JPEGSaveOptions();
    jpegOpt.embedColorProfile = FORMAT_DATA._colorProfile;
    jpegOpt.quality = num_1 ;
    jpegOpt.formatOptions =  FORMAT_DATA._formatOptions;  
    jpegOpt.scans = num_2;
    jpegOpt.matte = FORMAT_DATA._matte; 
    activeDocument.saveAs(fileObj, jpegOpt, true, Extension.LOWERCASE);
}

//関数：tga保存
function Save_Tga(newName,newPath){
    fileObj = new File(newPath+"/"+ newName +".tga");
    tgaOpt = new TargaSaveOptions();
    tgaOpt.alphaChannels = true;
    tgaOpt.resolution = FORMAT_DATA._resolution;
    tgaOpt.rleCompression = FORMAT_DATA._rleCompression;
    activeDocument.saveAs(fileObj, tgaOpt, true, Extension.LOWERCASE);
}

//関数：psd保存
function Save_Psd(newName,newPath){
    fileObj = new File(newPath+"/"+ newName +"@.psd");
    psdOpt = new PhotoshopSaveOptions();
    psdOpt.alphaChannels = FORMAT_DATA._aChannels;
    psdOpt.annotations = FORMAT_DATA._annotations;
    psdOpt.embedColorProfile = FORMAT_DATA._colorProfile;
    psdOpt.layers = FORMAT_DATA._layers;
    psdOpt.spotColors = FORMAT_DATA._spotColors;
    activeDocument.saveAs(fileObj, psdOpt, true, Extension.LOWERCASE);
}

//関数：web書き出しjpg保存
function Save_WebJpg(newName,newPath){
    var num_1 = FORMAT_DATA._quality; 
    if(num_1 < 0){
      num_1 = 0 ;  
    }
    if(num_1 > 12){
      num_1 = 12 ;  
    }
    var num_2 = FORMAT_DATA._scans;  
    if(num_2 < 3){
      num_2 = 3 ;  
    }
    if(num_2 > 5){
      num_2 = 5 ;  
    }
    var jpgOpt = new ExportOptionsSaveForWeb();
        jpgOpt.format = SaveDocumentType.JPEG;
        jpgOpt.includeProfile = false;
        jpgOpt.interlaced = FORMAT_DATA._interlaced;
        jpgOpt.optimized = true;
        jpgOpt.quality = FORMAT_DATA._webJpgQuality;
        jpgOpt.blur = 0;
        jpgOpt.matteColor = new RGBColor();
        jpgOpt.matteColor.red = 255;
        jpgOpt.matteColor.green = 255;
        jpgOpt.matteColor.blue = 255; 
        
    //書き出し
    var outPath = new File(newPath+"/"+ newName +".jpg");
    activeDocument.exportDocument(outPath ,ExportType.SAVEFORWEB,jpgOpt);
}

//関数：web書き出しpng保存
function Save_WebPng(newName,newPath){
        var pngOpt = new ExportOptionsSaveForWeb();
            pngOpt.format = SaveDocumentType.PNG;
            pngOpt.optimized = true;
            pngOpt.interlaced = FORMAT_DATA._interlaced;
            pngOpt.PNG8 = false;
            
        //書き出し
        var outPath = new File(newPath+"/"+ newName +".png");
        activeDocument.exportDocument(outPath ,ExportType.SAVEFORWEB,pngOpt);
}

//関数：web書き出しgif保存
function Save_WebGif(newName,newPath){
        var gifOpt = new ExportOptionsSaveForWeb();
            gifOpt.format = SaveDocumentType.COMPUSERVEGIF;
            gifOpt.quality = FORMAT_DATA._webGifQuality;
           
        //書き出し
        var outPath = new File(newPath+"/"+ newName +".gif");
        activeDocument.exportDocument(outPath, ExportType.SAVEFORWEB,gifOpt);
}

//関数：web書き出しウインドウを開く
function Save_WebOpen(){
    var idExpr = charIDToTypeID( "Expr" );
    var desc1 = new ActionDescriptor();
    var idUsng = charIDToTypeID( "Usng" );
    var idSaveForWeb = stringIDToTypeID( "SaveForWeb" );
    var desc2 = new ActionDescriptor();
    desc1.putObject( idUsng, idSaveForWeb, desc2 );
    executeAction( idExpr, desc1, DialogModes.ALL );
}

/*
■プログレスバー
*/
var pgbNum = 0;

//関数：プログレスバー
function UpdateProgressBar(){
    HideProgressBar();
    ShowProgressBar(); 
    pgbNum += 1;
    winPgb.info01.text = pgbNum.toString() ;
    winPgb.pBar.value += 1;
}
//関数：windowの作成
function CreateProgressBar(max){
    //プログレスバー定義
    const DEF = {
        progressTitle: "処理中・・・・・・",
    };

    winProgressBar = new Window('palette',DEF.progressTitle,);
    winPgb = winProgressBar.add("group");
    winPgb.orientation = "row";
    winPgb.pBar = winPgb.add("progressbar",[10,30,10+360,30+15], 0, max-1);
    winPgb.info01 = winPgb.add("statictext", undefined, max);
    winPgb.info02 = winPgb.add("statictext", undefined, "/");
    winPgb.info03 = winPgb.add("statictext", undefined, max-1);
    var str = max.toString() ;
    str = ("000000").slice(str.length *-1);
    winPgb.info01.text = str;
    
    winProgressBar.center();
    new ShowProgressBarWin();
}
   
//プログレスバーを非表示
function HideProgressBar(){
    winPgb.pBar.hide();
}

//プログレスバーを表示
function ShowProgressBar(){
    winProgressBar.active = true;
    winPgb.pBar.show();
}

//関数：windowを表示
function ShowProgressBarWin(){
    winProgressBar.show();
}






