﻿/*
■保存フォーマットを指定して保存するスクリプト  v190804
 　　必須スクリプト
        Lib_generalMethod.jsx

　▼構造前提条件
*/
#include "Lib_generalMethod.jsx"  

//ドキュメントの各種定義
var docObj = activeDocument;//ドキュメント
var docNamePsd = docObj.name;//ドキュメント名
var docName = docNamePsd.substring( 0, docNamePsd.length-4 );//拡張子抜き
var newName = docName;
var newPath = docObj.path + "/" ;//ドキュメントパス
docObj.activeLayer = docObj.layers[0];//active化
const DEF = {
    dialogCancel:"Cancelされました",
    formatPng:"png",
    formatJpg:"jpg",
    formatTga:"tga",
    formatPsd:"psd",
    formatWebPng:"web　png",
    formatWebJpg:"web　jpg",
    formatWebGif:"web gif",
};
var saveFormat = DEF.formatPng;
/*
    beginning phase
*/
Act_CreateFolder("Export");//フォルダの作成
newPath = newPath + "Export/";
try{
    FormatSelect();
    app.activeDocument.suspendHistory("script：Run_ExportSave", "SavePsd()");
}    
catch(e){
alert("info("+e+")");
}
/*
    end phase
*/
activeDocument.close(SaveOptions.DONOTSAVECHANGES);
/*
    GUI
*/
function FormatSelect(){
    //ダイアログ追加
    var dialog = new Window("dialog","FormatSelect");
    var formatText = dialog.add("group");
    formatText.alignment = [ScriptUI.Alignment.CENTER,ScriptUI.Alignment.CENTER];
    formatText.Pnl = formatText.add("panel",undefined, "■Save Format");
    
	//フォーマット選択
	var formatPanel = formatText.Pnl.add("group");
    formatPanel.alignment = [ScriptUI.Alignment.CENTER,ScriptUI.Alignment.CENTER ];
    formatPanel.BtnPos01 = formatPanel.add("radiobutton",undefined, DEF.formatPng);
    formatPanel.BtnPos02 = formatPanel.add("radiobutton",undefined, DEF.formatJpg);
    formatPanel.BtnPos03 = formatPanel.add("radiobutton",undefined, DEF.formatTga);
    formatPanel.BtnPos04 = formatPanel.add("radiobutton",undefined, DEF.formatPsd);
    formatPanel.BtnPos05 = formatPanel.add("radiobutton",undefined, DEF.formatWebPng);
    formatPanel.BtnPos06 = formatPanel.add("radiobutton",undefined, DEF.formatWebJpg);
    formatPanel.BtnPos07 = formatPanel.add("radiobutton",undefined, DEF.formatWebGif);
 
    //処理選択初期設定
    formatPanel.BtnPos01.value = true;

	//ボタン
	var buttons = dialog.add("group");
	buttons.orientation = "row";
	buttons.alignment = "bottom";
	var okBtn = buttons.add("button");
	okBtn.text = "OK";
	okBtn.properties = {name: "ok"};
	var cancelBtn = buttons.add("button");
	cancelBtn.text = "Cancel";
	cancelBtn.properties = {name: "cancel"};
	
	//レイアウト
	dialog.center();
    if (dialog.show() == 1) {
        if(formatPanel.BtnPos01.value == true){
            saveFormat = DEF.formatPng;
        } else if(formatPanel.BtnPos02.value == true){
            saveFormat = DEF.formatJpg;
        } else if(formatPanel.BtnPos03.value == true){
            saveFormat = DEF.formatTga;
        } else if(formatPanel.BtnPos04.value == true){
            saveFormat = DEF.formatPsd;
        } else if(formatPanel.BtnPos05.value == true){
            saveFormat = "webPng";
        } else if(formatPanel.BtnPos06.value == true){
            saveFormat = "webJpg";
        } else if(formatPanel.BtnPos07.value == true){
            saveFormat = "webGif";
        }
    }else{
        throw DEF.dialogCancel;
    }
}
//関数：psdを各フォーマットへ保存
function SavePsd(){
    Save_Branch(saveFormat);
}